#ifndef _SHADER_H_
#define _SHADER_H_

// trieda premennych a funkcii (objektov) pre pracu so shadermi
// VertexShaderProgram a FragmentShaderProgram (ARB a NV)
// GLSL vertex & fragment program
class CShader {
public:
 CShader();  // konstruktor
 ~CShader(); // destruktor

 // nacitanie kodu ShaderProgramu
 int PRGload(const char *SRC);

 void PRGenable(void);  // zapnutie ShaderProgramu
 void PRGdisable(void); // vypnutie ShaderProgramu
 void PRGbind(void);    // pripojenie ShaderProgramu

 // vlozenie Environment parametra do ShaderProgramu
 void PRGenv_param(const GLuint I,const vec4 P);
 // vlozenie Local parametra do ShaderProgramu
 void PRGlocal_param(const GLuint I,const vec4 P);

 // nacitanie kodu GLSL vertex & fragment shadera
 int GLSLload(const char *VP,const char *FP);
 void GLSLon(void);  // zapnutie GLSL shadera
 void GLSLoff(void); // vypnutie GLSL shadera
 // nastavenie parametrov GLSL shadera
 void GLSLuniformI(const char *NAME,const int I);
 void GLSLuniformF(const char *NAME,const float F0,const float F1,const float F2,const float F3);
 void GLSLuniformmatrixFV(const char *NAME,const float *FV);
private:
 char *sh_code; // kod ShaderProgramu

 GLuint target;  // typ objektu ShaderProgramu
 GLuint id;      // identifikator objektu ShaderProgramu
 GLint err_line; // cislo chybneho riadku ShaderProgramu

 GLfloat v[4]; // pomocna premenna

 GLhandleARB glsl_object; // GLSL program object
 GLint loc;               // umiestnenie premennej GLSL shadera

 // nacitanie obsahu textoveho suboru
 char *TextFileRead(const char *FNAME);
};

#endif
